{****************************
 *                          *
 * Autor: Adrian M. Hanslik *
 * Date 06. June 1999       *
 * Version: 1.0             *
 *                          *
 ****************************}

unit AMHTrafficLVecStd;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TBorderStyle = (bsNone, bsStd, esPro);

  TState = (sAll, sAmber, sGreen, sNone, sRed, sRedAmber);

  TAMHTrafficLVecStd = class(TGraphicControl)
  private
    { Private-Deklarationen }
    fBorderStyle: TBorderStyle;
    fState: TState;
    procedure SetBorderStyle(Value: TBorderStyle);
    procedure SetState(Value: TState);
  protected
    { Protected-Deklarationen }
    procedure DrawEllipseBorder(NewLeft, NewTop, NewWidth, NewHeight: Integer);
    procedure Paint; override;
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    { Published-Deklarationen }
    property BorderStyle: TBorderStyle read fBorderStyle write SetBorderStyle;
    property State: TState read fState write SetState;
  end;

implementation

constructor TAMHTrafficLVecStd.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Height := 48;
  Width := 16;
  fBorderStyle := bsNone;
  fState := sRed;
end;

destructor TAMHTrafficLVecStd.Destroy;
begin
  inherited Destroy;
end;

procedure TAMHTrafficLVecStd.DrawEllipseBorder(NewLeft, NewTop, NewWidth, NewHeight: Integer);
begin
  with Canvas do begin
       if fBorderStyle = bsNone then begin
          Pen.Color := Brush.Color;
          Arc(NewLeft, NewTop, NewWidth, NewHeight, 0, 0, 0, 0)
       end else if fBorderStyle = bsStd then begin
                   Pen.Color := clBlack;
                   Arc(NewLeft, NewTop, NewWidth, NewHeight, 0, 0, 0, 0)
       end else begin
                  Pen.Color := clLtGray;
                  Arc(NewLeft, NewTop, NewWidth, NewHeight, NewWidth, 0, 0, NewHeight);
                  Pen.Color := clDkGray;
                  Arc(NewLeft, NewTop, NewWidth, NewHeight, 0, NewHeight, NewWidth, 0);
       end;
  end;
end;

procedure TAMHTrafficLVecStd.Paint;
begin
  with Canvas do begin
       if (fState = sAll) or (fState = sRed) or (fState = sRedAmber) then
          Brush.Color := clRed
       else
           Brush.Color := $0000007F;
       Ellipse(0, 0, Width, Height div 3);
       DrawEllipseBorder(0, 0, Width, Height div 3);
       if (fState = sAll) or (fState = sAmber) or (fState = sRedAmber) then
          Brush.Color := clYellow
       else
           Brush.Color := $00007F7F;
       Ellipse(0, Height div 3, Width, Height - Height div 3);
       DrawEllipseBorder(0, Height div 3, Width, Height - Height div 3);
       if (fState = sGreen) or (fState = sAll) then
          Brush.Color := clLime
       else
           Brush.Color := $00007F00;
       Ellipse(0, Height - Height div 3, Width, Height);
       DrawEllipseBorder(0, Height - Height div 3, Width, Height);
  end;
end;

procedure TAMHTrafficLVecStd.SetBorderStyle(Value: TBorderStyle);
begin
  if Value <> fBorderStyle then begin
     fBorderStyle := Value;
     Invalidate;
  end;
end;

procedure TAMHTrafficLVecStd.SetState(Value: TState);
begin
  if Value <> fState then begin
     fState := Value;
     Invalidate;
  end;
end;

end.
